## mtail 3.0.0~rc35

=== Makefile ===
# Copyright 2011 Google Inc. All Rights Reserved.
# This file is available under the Apache license.

export GO111MODULE ?= auto
# Build these.
TARGETS = mtail mgen mdot mfmt

all: $(TARGETS)

# Install them here
PREFIX ?= usr/local

# Place to store dependencies.
DEPDIR = .d
# Can't use a dependency rule here.
$(shell install -d $(DEPDIR))

# This rule finds all non-standard-library dependencies of each target and emits them to a makefile include.
# Thanks mrtazz: https://unwiredcouch.com/2016/05/31/go-make.html
MAKEDEPEND = echo "$@: $$(go list -f '{{if not .Standard}}{{.Dir}}{{end}}' $$(go list -f '{{ join .Deps "\n" }}' $<) | sed -e 's@$$@/*.go@' | tr "\n" " " )" > $(DEPDIR)/$@.d

# This rule allows the dependencies to not exist yet, for the first run.
$(DEPDIR)/%.d: ;
.PRECIOUS: $(DEPDIR)/%.d

# This instruction loads any dependency includes for our targets.
-include $(patsubst %,$(DEPDIR)/%.d,$(TARGETS))

# Set the timeout for tests run under the race detector.
timeout := 10m
ifeq ($(TRAVIS),true)
timeout := 20m
endif
ifeq ($(CIRCLECI),true)
timeout := 20m
endif
ifeq ($(CIRRUS_CI),true)
timeout := 20m
endif
# Let the benchmarks run for a long time.  The timeout is for the total time of
# all benchmarks, not per bench.
benchtimeout := 20m

# Be verbose with `go get`, if UPDATE is y then also update dependencies.
GOGETFLAGS = -v
ifeq ($(UPDATE),y)
GOGETFLAGS += -u
endif

GOFILES=$(shell find . -name '*.go' -a ! -name '*_test.go')

GOTESTFILES=$(shell find . -name '*_test.go')

GOGENFILES=internal/vm/parser/parser.go\
	internal/mtail/logo.ico.go


CLEANFILES+=\
	internal/vm/parser/parser.go\
	internal/vm/parser/y.output\
	internal/mtail/logo.ico.go\
	internal/mtail/logo.ico\

# A place to install tool dependencies.
GOBIN ?= $(firstword $(subst :, ,$(GOPATH)))/bin

TOGO = $(GOBIN)/togo
$(TOGO):
	go get $(GOGETFLAGS) github.com/flazz/togo

GOYACC = $(GOBIN)/goyacc
$(GOYACC):
	go get $(GOGETFLAGS) golang.org/x/tools/cmd/goyacc

GOFUZZBUILD = $(GOBIN)/go-fuzz-build
$(GOFUZZBUILD):
	go get $(GOGETFLAGS) github.com/dvyukov/go-fuzz/go-fuzz-build

GOFUZZ = $(GOBIN)/go-fuzz
$(GOFUZZ):
	go get $(GOGETFLAGS) github.com/dvyukov/go-fuzz/go-fuzz

GOVERALLS = $(GOBIN)/goveralls
$(GOVERALLS):
	go get $(GOGETFLAGS) github.com/mattn/goveralls

GOX = $(GOBIN)/gox
$(GOX):
	go get github.com/mitchellh/gox

GOTESTSUM = $(GOBIN)/gotestsum
$(GOTESTSUM):
	go get gotest.tools/gotestsum


.PHONY: clean covclean crossclean depclean
clean: covclean crossclean
	rm -f $(CLEANFILES)
covclean:
	rm -f *.coverprofile coverage.html $(COVERPROFILES)
crossclean:
	rm -rf build
depclean:
	rm -f .d/*  .*dep-stamp

.PHONY: lint
lint:
	golangci-lint run ./...

branch := $(shell git rev-parse --abbrev-ref HEAD)
version := $(shell git describe --tags --always --dirty)
revision := $(shell git rev-parse HEAD)
release := $(shell git describe --tags --always --dirty | cut -d"-" -f 1,2)

GO_LDFLAGS := -X main.Branch=${branch} -X main.Version=${version} -X main.Revision=${revision}

ifeq ($(STATIC),y)
	# -s Omit symbol table and debug info
	# -w Omit DWARF symbol table
	# -extldflags -static and CGO_ENABLED=0 to make pure static
	GO_LDFLAGS += -w -s -extldflags "-static"
	export CGO_ENABLED=0
endif

# Very specific static pattern rule to only do this for commandline targets.
# Each commandline must be in a 'main.go' in their respective directory.  The
# MAKEDEPEND rule generates a list of dependencies for the next make run -- the
# first time the rule executes because the target doesn't exist, subsequent
# runs can read the dependencies and update iff they change.
$(TARGETS): %: cmd/%/main.go $(DEPDIR)/%.d | print-version .dep-stamp
	$(MAKEDEPEND)
	go build -ldflags "$(GO_LDFLAGS)" -o $@ $<

internal/vm/parser/parser.go: internal/vm/parser/parser.y | $(GOYACC)
	go generate -x ./$(@D)

internal/mtail/logo.ico: logo.png
	/usr/bin/convert $< -define icon:auto-resize=64,48,32,16 $@ || touch $@

internal/mtail/logo.ico.go: | internal/mtail/logo.ico $(TOGO)
	$(TOGO) -pkg mtail -name logoFavicon -input internal/mtail/logo.ico


###
## Emit the current toolchain version at the start of every goal, if that goal depends on this.
#
.PHONY: print-version
print-version:
	@go version

###
## Install rules
#
# Would subst all $(TARGETS) except other binaries are just for development.
INSTALLED_TARGETS = $(PREFIX)/bin/mtail

.PHONY: install
install: $(INSTALLED_TARGETS)

$(PREFIX)/bin/%: %
	install -d $(@D)
	install -m 755 $< $@


GOX_OSARCH ?= "linux/amd64 windows/amd64 darwin/amd64"
#GOX_OSARCH := ""

.PHONY: crossbuild
crossbuild: $(GOFILES) $(GOGENFILES) | $(GOX) .dep-stamp print-version
	mkdir -p build
	gox --output="./build/mtail_${release}_{{.OS}}_{{.Arch}}" -osarch=$(GOX_OSARCH) -ldflags "$(GO_LDFLAGS)" ./cmd/mtail

.PHONY: test check
check test: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version $(LOGO_GO) .dep-stamp
	go test -timeout 10s ./...

.PHONY: testrace
testrace: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version $(LOGO_GO) .dep-stamp
	go test -timeout ${timeout} -race -v -tags=integration ./...

.PHONY: smoke
smoke: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp
	go test -timeout 1s -test.short ./...

.PHONY: bench
bench: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp
	go test -tags=integration -bench=. -timeout=${benchtimeout} -benchtime=5s -run=BenchmarkProgram ./...

.PHONY: bench_cpu
bench_cpu: | print-version .dep-stamp
	go test -tags=integration -bench=. -run=BenchmarkProgram -timeout=${benchtimeout} -benchtime=5s -cpuprofile=cpu.out internal/mtail/examples_integration_test.go
.PHONY: bench_mem
bench_mem: | print-version .dep-stamp
	go test -tags=integration -bench=. -run=BenchmarkProgram -timeout=${benchtimeout} -benchtime=5s -memprofile=mem.out internal/mtail/examples_integration_test.go

.PHONY: recbench
recbench: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp
	go test -bench=. -run=XXX --record_benchmark ./...

.PHONY: regtest
regtest: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp
	go test -v -tags=integration -timeout=${timeout} ./...

TESTRESULTS ?= test-results
TESTCOVERPROFILE ?= out.coverprofile

.PHONY: junit-regtest
junit-regtest: $(TESTRESULTS)/test-output.xml $(TESTCOVERPROFILE)
$(TESTRESULTS)/test-output.xml $(TESTCOVERPROFILE): $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp $(GOTESTSUM)
	mkdir -p $(TESTRESULTS)
	$(GOTESTSUM) --junitfile $(TESTRESULTS)/test-output.xml -- -race -coverprofile=$(TESTCOVERPROFILE) --covermode=atomic -tags=integration -v -timeout=${timeout} ./...

PACKAGES := $(shell go list -f '{{.Dir}}' ./... | grep -v /vendor/ | grep -v /cmd/ | sed -e "s@$$(pwd)@.@")

.PHONY: testall
testall: testrace bench regtest

IMPORTS := $(shell go list -f '{{join .Imports "\n"}}' ./... | sort | uniq | grep -v mtail)
TESTIMPORTS := $(shell go list -f '{{join .TestImports "\n"}}' ./... | sort | uniq | grep -v mtail)

## make u a container
.PHONY: container
container: Dockerfile
	docker build -t mtail \
		--build-arg version=${version} \
	    --build-arg commit_hash=${revision} \
	    --build-arg build_date=$(shell date -Iseconds --utc) \
	    .

# Append the bin subdirs of every element of the GOPATH list to PATH, so we can find goyacc.
empty :=
space := $(empty) $(empty)
export PATH := $(PATH):$(subst $(space),:,$(patsubst %,%/bin,$(subst :, ,$(GOPATH))))

###
## Fuzz testing
#

# These flags set compatibility with OSS-Fuzz
CXX ?= clang-9
CXXFLAGS ?=
LIB_FUZZING_ENGINE ?= -libfuzzer
OUT ?= .

$(OUT)/vm-fuzzer: $(GOFILES) | $(GOFUZZBUILD)
	$(GOFUZZBUILD) -libfuzzer -o fuzzer.a ./internal/vm
	$(CXX) $(CXXFLAGS) $(LIB_FUZZING_ENGINE) fuzzer.a -lpthread -o $(OUT)/vm-fuzzer

$(OUT)/vm-fuzzer.dict: mgen
	./mgen --dictionary | sort > $@

$(OUT)/vm-fuzzer_seed_corpus.zip: $(wildcard examples/*.mtail) $(wildcard internal/vm/fuzz/*.mtail)
	zip -j $@ $^

.INTERMEDIATE: SEED
SEED: $(OUT)/vm-fuzzer_seed_corpus.zip
	mkdir -p SEED
	unzip -o -d SEED $<

.PHONY: fuzz
fuzz: SEED $(OUT)/vm-fuzzer $(OUT)/vm-fuzzer.dict
	mkdir -p CORPUS
	$(OUT)/vm-fuzzer -dict=$(OUT)/vm-fuzzer.dict CORPUS SEED

.PHONY: fuzz-regtest
fuzz-regtest: $(OUT)/vm-fuzzer SEED
	$(OUT)/vm-fuzzer $(wildcard SEED/*.mtail)

CRASH ?=

.PHONY: fuzz-repro
fuzz-repro: $(OUT)/vm-fuzzer mtail
	$(OUT)/vm-fuzzer $(CRASH) || true  # Want to continue
	./mtail --logtostderr --vmodule=checker=2,types=2 --mtailDebug=3 --dump_ast_types --dump_bytecode --compile_only --progs $(CRASH)

# make fuzz-min CRASH=example crash
.PHONY: fuzz-min
fuzz-min: $(OUT)/vm-fuzzer $(OUT)/vm-fuzzer.dict
	$(OUT)/vm-fuzzer -dict=$(OUT)/vm-fuzzer.dict -minimize_crash=1 -runs=10000 $(CRASH)

###
## dependency section
#
.PHONY: install_deps
install_deps: .dep-stamp
.dep-stamp: | $(GOGENFILES) print-version
	@echo "Install all dependencies, ensuring they're updated"
ifeq ($(GO111MODULE),on)
	go get $(GOGETFLAGS) -t ./...
else
	go get $(GOGETFLAGS) $(IMPORTS)
	go get $(GOGETFLAGS) $(TESTIMPORTS)
endif
	touch $@


###
## Coverage
#
.PHONY: coverage covrep

coverage: coverprofile

coverprofile: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version $(LOGO_GO) .dep-stamp
	go test -v -covermode=count -coverprofile=$@ -tags=integration -timeout=${timeout} $(PACKAGES)

coverage.html: coverprofile | print-version
	go tool cover -html=$< -o $@

covrep: coverage.html
	xdg-open $<

ifeq ($(CIRRUS_CI),true)
  COVERALLS_SERVICE := cirrus-ci
endif
ifeq ($(CIRCLECI),true)
  COVERALLS_SERVICE := circle-ci
endif
ifeq ($(TRAVIS),true)
  COVERALLS_SERVICE := travis-ci
endif

.PHONY: upload_to_coveralls
upload_to_coveralls: | coverprofile $(GOVERALLS)
	$(GOVERALLS) -coverprofile=coverprofile -service=$(COVERALLS_SERVICE)


###
## CircleCI development targets
#

.PHONY: circleci-validate
circleci-validate: .circleci/config.yml
	circleci config validate

# Override this on the make command to say which job to run
CIRCLEJOB ?= fuzzing
.PHONY: circleci-execute
.INTERMEDIATE: tmpconfig.yml
circleci-execute: .circleci/config.yml circleci-validate
ifeq ($(CIRCLECI),true)
	$(error "Don't run this target from within CircleCI!")
endif
	circleci config process $< > tmpconfig.yml
	circleci local execute -c tmpconfig.yml --job $(CIRCLEJOB)

=== debian/changelog ===
mtail (3.0.0~rc35-3) unstable; urgency=medium

  * Team upload.
  * Add .service file (Closes: #886894)

 -- Antoine Beaupré <anarcat@debian.org>  Fri, 24 Apr 2020 16:22:36 -0400

mtail (3.0.0~rc35-2) unstable; urgency=medium

  * Team upload.
  * Ignore known test failure on 32-bit architectures, reported upstream
    as https://github.com/google/mtail/issues/313

 -- Antoine Beaupré <anarcat@debian.org>  Thu, 23 Apr 2020 17:21:10 -0400

mtail (3.0.0~rc35-1) unstable; urgency=medium

  * Team upload.
  * New upstream release, with jaeger support patched out because missing
    from Debian (Closes: #958417)
  * fix test suite (Closes: #952333)

 -- Antoine Beaupré <anarcat@debian.org>  Tue, 21 Apr 2020 15:09:07 -0400

=== debian/control ===
Source: mtail
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Martín Ferrari <tincho@debian.org>,
Section: net
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends: debhelper (>= 11),
               dh-golang (>= 1.17~),
               golang-any,
               golang-github-fsnotify-fsnotify-dev,
               golang-github-golang-groupcache-dev,
               golang-github-google-go-cmp-dev,
               golang-github-pkg-errors-dev,
               golang-github-prometheus-client-golang-dev,
               golang-glog-dev,
               golang-go.opencensus-dev,
               golang-golang-x-tools,
               tzdata,
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/go-team/packages/mtail
Vcs-Git: https://salsa.debian.org/go-team/packages/mtail.git
Homepage: https://github.com/google/mtail/
XS-Go-Import-Path: github.com/google/mtail

Package: mtail
Architecture: any
Depends: adduser,
         daemon,
         tzdata,
         ${misc:Depends},
         ${shlibs:Depends},
Conflicts: monkeytail,
Built-Using: ${misc:Built-Using},
Description: Extract monitoring data from logs for collection in a timeseries database
 Mtail is a tool for extracting metrics from application logs to be exported
 into a timeseries database or timeseries calculator for alerting and
 dashboarding.
 .
 It aims to fill a niche between applications that do not export their own
 internal state, and existing monitoring systems, without patching those
 applications or rewriting the same framework for custom extraction glue code.
 .
 Metrics are exported for scraping by a collector as JSON or Prometheus format
 over HTTP, or can be periodically sent to a collectd, StatsD, or Graphite
 collector socket.

## mtail 3.0.0~rc38

=== Makefile ===
--- 
+++ 
@@ -28,13 +28,7 @@
 
 # Set the timeout for tests run under the race detector.
 timeout := 10m
-ifeq ($(TRAVIS),true)
-timeout := 20m
-endif
-ifeq ($(CIRCLECI),true)
-timeout := 20m
-endif
-ifeq ($(CIRRUS_CI),true)
+ifeq ($(CI),true)
 timeout := 20m
 endif
 # Let the benchmarks run for a long time.  The timeout is for the total time of
@@ -72,9 +66,9 @@
 $(GOYACC):
 	go get $(GOGETFLAGS) golang.org/x/tools/cmd/goyacc
 
-GOFUZZBUILD = $(GOBIN)/go-fuzz-build
+GOFUZZBUILD = $(GOBIN)/go114-fuzz-build
 $(GOFUZZBUILD):
-	go get $(GOGETFLAGS) github.com/dvyukov/go-fuzz/go-fuzz-build
+	go get $(GOGETFLAGS) github.com/mdempsky/go114-fuzz-build
 
 GOFUZZ = $(GOBIN)/go-fuzz
 $(GOFUZZ):
@@ -115,12 +109,14 @@
 GO_LDFLAGS := -X main.Branch=${branch} -X main.Version=${version} -X main.Revision=${revision}
 
 ifeq ($(STATIC),y)
-	# -s Omit symbol table and debug info
-	# -w Omit DWARF symbol table
-	# -extldflags -static and CGO_ENABLED=0 to make pure static
-	GO_LDFLAGS += -w -s -extldflags "-static"
-	export CGO_ENABLED=0
+# -s Omit symbol table and debug info
+# -w Omit DWARF symbol table
+# -extldflags -static and CGO_ENABLED=0 to make pure static
+GO_LDFLAGS += -w -s -extldflags "-static"
+export CGO_ENABLED=0
 endif
+
+GO_GCFLAGS = -e
 
 # Very specific static pattern rule to only do this for commandline targets.
 # Each commandline must be in a 'main.go' in their respective directory.  The
@@ -129,7 +125,7 @@
 # runs can read the dependencies and update iff they change.
 $(TARGETS): %: cmd/%/main.go $(DEPDIR)/%.d | print-version .dep-stamp
 	$(MAKEDEPEND)
-	go build -ldflags "$(GO_LDFLAGS)" -o $@ $<
+	go build -gcflags "$(GO_GCFLAGS)" -ldflags "$(GO_LDFLAGS)" -o $@ $<
 
 internal/vm/parser/parser.go: internal/vm/parser/parser.y | $(GOYACC)
 	go generate -x ./$(@D)
@@ -162,7 +158,7 @@
 	install -m 755 $< $@
 
 
-GOX_OSARCH ?= "linux/amd64 windows/amd64 darwin/amd64"
+GOX_OSARCH ?= "linux/amd64 windows/amd64 darwin/amd64 linux/arm linux/arm64 linux/ppc64"
 #GOX_OSARCH := ""
 
 .PHONY: crossbuild
@@ -172,26 +168,26 @@
 
 .PHONY: test check
 check test: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version $(LOGO_GO) .dep-stamp
-	go test -timeout 10s ./...
+	go test -gcflags "$(GO_GCFLAGS)" -timeout 10s ./...
 
 .PHONY: testrace
 testrace: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version $(LOGO_GO) .dep-stamp
-	go test -timeout ${timeout} -race -v -tags=integration ./...
+	go test -gcflags "$(GO_GCFLAGS)" -timeout ${timeout} -race -v ./...
 
 .PHONY: smoke
 smoke: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp
-	go test -timeout 1s -test.short ./...
+	go test -gcflags "$(GO_GCFLAGS)" -timeout 1s -test.short ./...
 
 .PHONY: bench
 bench: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp
-	go test -tags=integration -bench=. -timeout=${benchtimeout} -benchtime=5s -run=BenchmarkProgram ./...
+	go test -gcflags "$(GO_GCFLAGS)" -bench=. -timeout=${benchtimeout} -benchtime=5s -run=BenchmarkProgram ./...
 
 .PHONY: bench_cpu
 bench_cpu: | print-version .dep-stamp
-	go test -tags=integration -bench=. -run=BenchmarkProgram -timeout=${benchtimeout} -benchtime=5s -cpuprofile=cpu.out internal/mtail/examples_integration_test.go
+	go test -bench=. -run=BenchmarkProgram -timeout=${benchtimeout} -benchtime=5s -cpuprofile=cpu.out internal/mtail/examples_integration_test.go
 .PHONY: bench_mem
 bench_mem: | print-version .dep-stamp
-	go test -tags=integration -bench=. -run=BenchmarkProgram -timeout=${benchtimeout} -benchtime=5s -memprofile=mem.out internal/mtail/examples_integration_test.go
+	go test -bench=. -run=BenchmarkProgram -timeout=${benchtimeout} -benchtime=5s -memprofile=mem.out internal/mtail/examples_integration_test.go
 
 .PHONY: recbench
 recbench: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp
@@ -199,7 +195,7 @@
 
 .PHONY: regtest
 regtest: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp
-	go test -v -tags=integration -timeout=${timeout} ./...
+	go test -gcflags "$(GO_GCFLAGS)" -v -timeout=${timeout} ./...
 
 TESTRESULTS ?= test-results
 TESTCOVERPROFILE ?= out.coverprofile
@@ -208,7 +204,7 @@
 junit-regtest: $(TESTRESULTS)/test-output.xml $(TESTCOVERPROFILE)
 $(TESTRESULTS)/test-output.xml $(TESTCOVERPROFILE): $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp $(GOTESTSUM)
 	mkdir -p $(TESTRESULTS)
-	$(GOTESTSUM) --junitfile $(TESTRESULTS)/test-output.xml -- -race -coverprofile=$(TESTCOVERPROFILE) --covermode=atomic -tags=integration -v -timeout=${timeout} ./...
+	$(GOTESTSUM) --junitfile $(TESTRESULTS)/test-output.xml -- -race -parallel 1 -coverprofile=$(TESTCOVERPROFILE) --covermode=atomic -v -timeout=${timeout} -gcflags "$(GO_GCFLAGS)" ./...
 
 PACKAGES := $(shell go list -f '{{.Dir}}' ./... | grep -v /vendor/ | grep -v /cmd/ | sed -e "s@$$(pwd)@.@")
 
@@ -239,11 +235,11 @@
 # These flags set compatibility with OSS-Fuzz
 CXX ?= clang-9
 CXXFLAGS ?=
-LIB_FUZZING_ENGINE ?= -libfuzzer
+LIB_FUZZING_ENGINE ?= -fsanitize=fuzzer
 OUT ?= .
 
 $(OUT)/vm-fuzzer: $(GOFILES) | $(GOFUZZBUILD)
-	$(GOFUZZBUILD) -libfuzzer -o fuzzer.a ./internal/vm
+	$(GOFUZZBUILD) -o fuzzer.a ./internal/vm
 	$(CXX) $(CXXFLAGS) $(LIB_FUZZING_ENGINE) fuzzer.a -lpthread -o $(OUT)/vm-fuzzer
 
 $(OUT)/vm-fuzzer.dict: mgen
@@ -252,7 +248,7 @@
 $(OUT)/vm-fuzzer_seed_corpus.zip: $(wildcard examples/*.mtail) $(wildcard internal/vm/fuzz/*.mtail)
 	zip -j $@ $^
 
-.INTERMEDIATE: SEED
+.INTERMEDIATE: SEED/*
 SEED: $(OUT)/vm-fuzzer_seed_corpus.zip
 	mkdir -p SEED
 	unzip -o -d SEED $<
@@ -264,14 +260,14 @@
 
 .PHONY: fuzz-regtest
 fuzz-regtest: $(OUT)/vm-fuzzer SEED
-	$(OUT)/vm-fuzzer $(wildcard SEED/*.mtail)
+	$(OUT)/vm-fuzzer -rss_limit_mb=4096 $(shell ls SEED/*.mtail)
 
 CRASH ?=
 
 .PHONY: fuzz-repro
 fuzz-repro: $(OUT)/vm-fuzzer mtail
 	$(OUT)/vm-fuzzer $(CRASH) || true  # Want to continue
-	./mtail --logtostderr --vmodule=checker=2,types=2 --mtailDebug=3 --dump_ast_types --dump_bytecode --compile_only --progs $(CRASH)
+	./mtail --logtostderr --vmodule=loader=2,checker=2,types=2 --mtailDebug=3 --dump_ast_types --dump_bytecode --compile_only --progs $(CRASH)
 
 # make fuzz-min CRASH=example crash
 .PHONY: fuzz-min
@@ -302,7 +298,7 @@
 coverage: coverprofile
 
 coverprofile: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version $(LOGO_GO) .dep-stamp
-	go test -v -covermode=count -coverprofile=$@ -tags=integration -timeout=${timeout} $(PACKAGES)
+	go test -v -covermode=count -coverprofile=$@ -timeout=${timeout} $(PACKAGES)
 
 coverage.html: coverprofile | print-version
 	go tool cover -html=$< -o $@
@@ -310,36 +306,19 @@
 covrep: coverage.html
 	xdg-open $<
 
-ifeq ($(CIRRUS_CI),true)
-  COVERALLS_SERVICE := cirrus-ci
-endif
-ifeq ($(CIRCLECI),true)
-  COVERALLS_SERVICE := circle-ci
-endif
-ifeq ($(TRAVIS),true)
-  COVERALLS_SERVICE := travis-ci
-endif
-
-.PHONY: upload_to_coveralls
-upload_to_coveralls: | coverprofile $(GOVERALLS)
-	$(GOVERALLS) -coverprofile=coverprofile -service=$(COVERALLS_SERVICE)
-
-
-###
-## CircleCI development targets
-#
-
-.PHONY: circleci-validate
-circleci-validate: .circleci/config.yml
-	circleci config validate
-
-# Override this on the make command to say which job to run
-CIRCLEJOB ?= fuzzing
-.PHONY: circleci-execute
-.INTERMEDIATE: tmpconfig.yml
-circleci-execute: .circleci/config.yml circleci-validate
-ifeq ($(CIRCLECI),true)
-	$(error "Don't run this target from within CircleCI!")
-endif
-	circleci config process $< > tmpconfig.yml
-	circleci local execute -c tmpconfig.yml --job $(CIRCLEJOB)
+###
+## Github issue tracking
+#
+GHI = $(GOBIN)/ghi
+$(GHI):
+	go get $(GOGETFLAGS) github.com/markbates/ghi
+
+issue-fetch: | $(GHI)
+	$(GHI) fetch
+
+issue-list: | $(GHI)
+	$(GHI) list
+
+ISSUE?=1
+issue-show: | $(GHI)
+	$(GHI) show $(ISSUE)

=== debian/changelog ===
mtail (3.0.0~rc38-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Refresh patches.

 -- Filippo Giunchedi <filippo@debian.org>  Fri, 27 Nov 2020 15:55:48 +0100

## mtail 3.0.0~rc41

=== debian/changelog ===
mtail (3.0.0~rc41-1) unstable; urgency=medium

  * New upstream release.
    + fix racy/flaky pipe tests (Closes: #976403, #979142)
  * Refresh patches.

 -- Filippo Giunchedi <filippo@debian.org>  Sat, 16 Jan 2021 17:41:57 +0100

mtail (3.0.0~rc38-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.

 -- Filippo Giunchedi <filippo@debian.org>  Tue, 01 Dec 2020 16:53:23 +0100

## mtail 3.0.0~rc43

=== Makefile ===
--- 
+++ 
@@ -1,9 +1,14 @@
 # Copyright 2011 Google Inc. All Rights Reserved.
 # This file is available under the Apache license.
 
-export GO111MODULE ?= auto
+export GO111MODULE ?= on
 # Build these.
 TARGETS = mtail mgen mdot mfmt
+
+GO_TEST_FLAGS ?= 
+BENCH_COUNT ?= 1
+BASE_REF ?= master
+HEAD_REF ?= $(shell git symbolic-ref HEAD -q --short | tr / - 2>/dev/null)
 
 all: $(TARGETS)
 
@@ -27,9 +32,9 @@
 -include $(patsubst %,$(DEPDIR)/%.d,$(TARGETS))
 
 # Set the timeout for tests run under the race detector.
+timeout := 120s
+ifeq ($(CI),true)
 timeout := 10m
-ifeq ($(CI),true)
-timeout := 20m
 endif
 # Let the benchmarks run for a long time.  The timeout is for the total time of
 # all benchmarks, not per bench.
@@ -57,6 +62,7 @@
 
 # A place to install tool dependencies.
 GOBIN ?= $(firstword $(subst :, ,$(GOPATH)))/bin
+export PATH := $(GOBIN):$(PATH)
 
 TOGO = $(GOBIN)/togo
 $(TOGO):
@@ -74,20 +80,16 @@
 $(GOFUZZ):
 	go get $(GOGETFLAGS) github.com/dvyukov/go-fuzz/go-fuzz
 
-GOVERALLS = $(GOBIN)/goveralls
-$(GOVERALLS):
-	go get $(GOGETFLAGS) github.com/mattn/goveralls
-
-GOX = $(GOBIN)/gox
-$(GOX):
-	go get github.com/mitchellh/gox
-
 GOTESTSUM = $(GOBIN)/gotestsum
 $(GOTESTSUM):
-	go get gotest.tools/gotestsum
-
-
-.PHONY: clean covclean crossclean depclean
+	go get $(GOGETFLAGS) gotest.tools/gotestsum
+
+BENCHSTAT = $(GOBIN)/benchstat
+$(BENCHSTAT):
+	go get $(GOGETFLAGS) golang.org/x/perf/cmd/benchstat
+
+
+.PHONY: clean covclean crossclean depclean veryclean
 clean: covclean crossclean
 	rm -f $(CLEANFILES)
 covclean:
@@ -96,6 +98,7 @@
 	rm -rf build
 depclean:
 	rm -f .d/*  .*dep-stamp
+veryclean: clean depclean
 
 .PHONY: lint
 lint:
@@ -116,6 +119,7 @@
 export CGO_ENABLED=0
 endif
 
+# Show all errors, not just limit to 10.
 GO_GCFLAGS = -e
 
 # Very specific static pattern rule to only do this for commandline targets.
@@ -134,7 +138,7 @@
 	/usr/bin/convert $< -define icon:auto-resize=64,48,32,16 $@ || touch $@
 
 internal/mtail/logo.ico.go: | internal/mtail/logo.ico $(TOGO)
-	$(TOGO) -pkg mtail -name logoFavicon -input internal/mtail/logo.ico
+	togo -pkg mtail -name logoFavicon -input internal/mtail/logo.ico
 
 
 ###
@@ -157,62 +161,49 @@
 	install -d $(@D)
 	install -m 755 $< $@
 
-
-GOX_OSARCH ?= "linux/amd64 windows/amd64 darwin/amd64 linux/arm linux/arm64 linux/ppc64"
-#GOX_OSARCH := ""
-
-.PHONY: crossbuild
-crossbuild: $(GOFILES) $(GOGENFILES) | $(GOX) .dep-stamp print-version
-	mkdir -p build
-	gox --output="./build/mtail_${release}_{{.OS}}_{{.Arch}}" -osarch=$(GOX_OSARCH) -ldflags "$(GO_LDFLAGS)" ./cmd/mtail
-
 .PHONY: test check
 check test: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version $(LOGO_GO) .dep-stamp
-	go test -gcflags "$(GO_GCFLAGS)" -timeout 10s ./...
+	go test $(GO_TEST_FLAGS) -gcflags "$(GO_GCFLAGS)" -timeout 10s ./...
 
 .PHONY: testrace
 testrace: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version $(LOGO_GO) .dep-stamp
-	go test -gcflags "$(GO_GCFLAGS)" -timeout ${timeout} -race -v ./...
+	go test $(GO_TEST_FLAGS) -gcflags "$(GO_GCFLAGS)" -timeout ${timeout} -race -v ./...
 
 .PHONY: smoke
-smoke: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp
-	go test -gcflags "$(GO_GCFLAGS)" -timeout 1s -test.short ./...
-
-.PHONY: bench
-bench: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp
-	go test -gcflags "$(GO_GCFLAGS)" -bench=. -timeout=${benchtimeout} -benchtime=5s -run=BenchmarkProgram ./...
-
-.PHONY: bench_cpu
-bench_cpu: | print-version .dep-stamp
-	go test -bench=. -run=BenchmarkProgram -timeout=${benchtimeout} -benchtime=5s -cpuprofile=cpu.out internal/mtail/examples_integration_test.go
-.PHONY: bench_mem
-bench_mem: | print-version .dep-stamp
-	go test -bench=. -run=BenchmarkProgram -timeout=${benchtimeout} -benchtime=5s -memprofile=mem.out internal/mtail/examples_integration_test.go
-
-.PHONY: recbench
-recbench: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp
-	go test -bench=. -run=XXX --record_benchmark ./...
+smoke: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version $(LOGO_GO) .dep-stamp
+	go test $(GO_TEST_FLAGS) -gcflags "$(GO_GCFLAGS)" -timeout 1s -test.short ./...
 
 .PHONY: regtest
-regtest: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp
-	go test -gcflags "$(GO_GCFLAGS)" -v -timeout=${timeout} ./...
+regtest: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version $(LOGO_GO) .dep-stamp
+	go test $(GO_TEST_FLAGS) -gcflags "$(GO_GCFLAGS)" -v -timeout=${timeout} ./...
 
 TESTRESULTS ?= test-results
 TESTCOVERPROFILE ?= out.coverprofile
 
 .PHONY: junit-regtest
 junit-regtest: $(TESTRESULTS)/test-output.xml $(TESTCOVERPROFILE)
+
 $(TESTRESULTS)/test-output.xml $(TESTCOVERPROFILE): $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp $(GOTESTSUM)
 	mkdir -p $(TESTRESULTS)
-	$(GOTESTSUM) --junitfile $(TESTRESULTS)/test-output.xml -- -race -parallel 1 -coverprofile=$(TESTCOVERPROFILE) --covermode=atomic -v -timeout=${timeout} -gcflags "$(GO_GCFLAGS)" ./...
+	gotestsum --debug --junitfile $(TESTRESULTS)/test-output.xml -- $(GO_TEST_FLAGS) -cpu 1,2,4 -race -parallel 1 -coverprofile=$(TESTCOVERPROFILE) --covermode=atomic -v -timeout=${timeout} -gcflags "$(GO_GCFLAGS)" ./...
+
+.PHONY: bench
+bench: $(TESTRESULTS)/benchmark-results-$(HEAD_REF).txt
+
+$(TESTRESULTS)/benchmark-results-$(HEAD_REF).txt: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp
+	mkdir -p $(TESTRESULTS)
+	go test -cpu 1,2,4 -bench=. -count=$(BENCH_COUNT) -timeout=${benchtimeout} -run=^a ./... | tee $@
+
+.PHONY: benchstat
+benchstat: $(TESTRESULTS)/benchstat.txt
+$(TESTRESULTS)/benchstat.txt: $(TESTRESULTS)/benchmark-results-$(HEAD_REF).txt | print-version $(BENCHSTAT)
+	(test -s $(TESTRESULTS)/benchmark-results-$(BASE_REF).txt && benchstat $(TESTRESULTS)/benchmark-results-$(BASE_REF).txt $< || benchstat $<) | tee $@
+
 
 PACKAGES := $(shell go list -f '{{.Dir}}' ./... | grep -v /vendor/ | grep -v /cmd/ | sed -e "s@$$(pwd)@.@")
 
 .PHONY: testall
 testall: testrace bench regtest
-
-IMPORTS := $(shell go list -f '{{join .Imports "\n"}}' ./... | sort | uniq | grep -v mtail)
-TESTIMPORTS := $(shell go list -f '{{join .TestImports "\n"}}' ./... | sort | uniq | grep -v mtail)
 
 ## make u a container
 .PHONY: container
@@ -239,7 +230,7 @@
 OUT ?= .
 
 $(OUT)/vm-fuzzer: $(GOFILES) | $(GOFUZZBUILD)
-	$(GOFUZZBUILD) -o fuzzer.a ./internal/vm
+	go114-fuzz-build -o fuzzer.a ./internal/vm
 	$(CXX) $(CXXFLAGS) $(LIB_FUZZING_ENGINE) fuzzer.a -lpthread -o $(OUT)/vm-fuzzer
 
 $(OUT)/vm-fuzzer.dict: mgen
@@ -280,13 +271,7 @@
 .PHONY: install_deps
 install_deps: .dep-stamp
 .dep-stamp: | $(GOGENFILES) print-version
-	@echo "Install all dependencies, ensuring they're updated"
-ifeq ($(GO111MODULE),on)
-	go get $(GOGETFLAGS) -t ./...
-else
-	go get $(GOGETFLAGS) $(IMPORTS)
-	go get $(GOGETFLAGS) $(TESTIMPORTS)
-endif
+	go mod download
 	touch $@
 
 
@@ -314,11 +299,11 @@
 	go get $(GOGETFLAGS) github.com/markbates/ghi
 
 issue-fetch: | $(GHI)
-	$(GHI) fetch
+	ghi fetch
 
 issue-list: | $(GHI)
-	$(GHI) list
+	ghi list
 
 ISSUE?=1
 issue-show: | $(GHI)
-	$(GHI) show $(ISSUE)
+	ghi show $(ISSUE)

=== debian/changelog ===
mtail (3.0.0~rc43-4) unstable; urgency=medium

  * Update init script, service unit, and defaults.
    This fixes bugs and updates the init script to properly support globs in
    the LOGS configuration variable, drop the `daemon` dependency, and other
    improvements made by Guillem Jover to pkg-prometheus init scripts.
    It also updates the systemd service file to reach feature-parity with the
    SysV init script, and the default file to document all available options.
  * Update to compat 13.
  * Update Standards-Version with no changes.
  * Update watchfile.

 -- Martina Ferrari <tina@debian.org>  Fri, 10 Dec 2021 11:37:08 +0000

mtail (3.0.0~rc43-3) unstable; urgency=medium

  * Mute spammy log messages when reading from named pipes.
    See also https://github.com/google/mtail/issues/462

 -- Filippo Giunchedi <filippo@debian.org>  Sun, 23 May 2021 20:56:53 +0200

mtail (3.0.0~rc43-2) unstable; urgency=medium

  * Use MemorySwapMax=0 with cgroups v2 / systemd unified hierarchy
    (Closes: #985354)

 -- Filippo Giunchedi <filippo@debian.org>  Tue, 16 Mar 2021 21:11:14 +0100

mtail (3.0.0~rc43-1) unstable; urgency=medium

  * New upstream release.

 -- Filippo Giunchedi <filippo@debian.org>  Thu, 21 Jan 2021 15:19:11 +0100

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: mtail
 Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
-Uploaders: Martín Ferrari <tincho@debian.org>,
+Uploaders: Martina Ferrari <tina@debian.org>,
 Section: net
 Testsuite: autopkgtest-pkg-go
 Priority: optional
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 13),
                dh-golang (>= 1.17~),
                golang-any,
                golang-github-fsnotify-fsnotify-dev,
@@ -16,7 +16,8 @@
                golang-go.opencensus-dev,
                golang-golang-x-tools,
                tzdata,
-Standards-Version: 4.3.0
+Standards-Version: 4.6.0.1
+Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/go-team/packages/mtail
 Vcs-Git: https://salsa.debian.org/go-team/packages/mtail.git
 Homepage: https://github.com/google/mtail/
@@ -25,7 +26,6 @@
 Package: mtail
 Architecture: any
 Depends: adduser,
-         daemon,
          tzdata,
          ${misc:Depends},
          ${shlibs:Depends},

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk

#export DH_VERBOSE=1
export DH_GOPKG := github.com/google/mtail
export DH_GOLANG_EXCLUDES := $(DH_GOPKG)/cmd/mgen $(DH_GOPKG)/cmd/mdot
export DH_GOLANG_INSTALL_EXTRA := examples/ \
    internal/mtail/golden/ internal/mtail/testdata/ \
    internal/vm/parser/parser.y
# Build parser.go
export DH_GOLANG_GO_GENERATE := 1

BUILDDIR := $(CURDIR)/build
BUILDFLAGS = -ldflags \
  " -X main.Version=$(DEB_VERSION_UPSTREAM)\
    -X main.Revision=$(DEB_VERSION)"

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=$(BUILDDIR)

override_dh_auto_build:
	dh_auto_build -- $(BUILDFLAGS)

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifeq ($(DEB_HOST_ARCH_BITS),64)
	dh_auto_test
else
	# soft fail on non 64-bit architectures:
	# https://github.com/google/mtail/issues/313
	dh_auto_test || echo "W: ignoring known test failure on 32-bit architectures"
endif
	# Only run race tests on amd64.
	test "$(DEB_HOST_ARCH_CPU)" != amd64 || \
            GOCACHE=$(BUILDDIR) GO111MODULE=off GOPROXY=off GOPATH=$(BUILDDIR) go test -v -timeout 5m -race -tags=integration \
                $(DH_GOPKG)/...
endif

override_dh_installinit:
	dh_installinit --no-enable --no-start

override_dh_installsystemd:
	dh_installsystemd --no-enable --no-start

override_dh_auto_install:
	dh_auto_install -- --no-source

## mtail 3.0.0~rc48

=== Makefile ===
--- 
+++ 
@@ -5,10 +5,12 @@
 # Build these.
 TARGETS = mtail mgen mdot mfmt
 
-GO_TEST_FLAGS ?= 
+GO_TEST_FLAGS ?=
 BENCH_COUNT ?= 1
-BASE_REF ?= master
-HEAD_REF ?= $(shell git symbolic-ref HEAD -q --short | tr / - 2>/dev/null)
+BASE_REF ?= main
+HEAD_REF ?= $(shell git symbolic-ref HEAD -q --short)
+BASE_REF := $(subst /,-,$(BASE_REF))
+HEAD_REF := $(subst /,-,$(HEAD_REF))
 
 all: $(TARGETS)
 
@@ -38,55 +40,57 @@
 endif
 # Let the benchmarks run for a long time.  The timeout is for the total time of
 # all benchmarks, not per bench.
-benchtimeout := 20m
-
-# Be verbose with `go get`, if UPDATE is y then also update dependencies.
-GOGETFLAGS = -v
-ifeq ($(UPDATE),y)
-GOGETFLAGS += -u
-endif
+benchtimeout := 120m
 
 GOFILES=$(shell find . -name '*.go' -a ! -name '*_test.go')
 
 GOTESTFILES=$(shell find . -name '*_test.go')
 
-GOGENFILES=internal/vm/parser/parser.go\
+GOGENFILES=internal/runtime/compiler/parser/parser.go\
 	internal/mtail/logo.ico.go
 
 
 CLEANFILES+=\
-	internal/vm/parser/parser.go\
-	internal/vm/parser/y.output\
+	internal/runtime/compiler/parser/parser.go\
+	internal/runtime/compiler/parser/y.output\
 	internal/mtail/logo.ico.go\
 	internal/mtail/logo.ico\
 
 # A place to install tool dependencies.
-GOBIN ?= $(firstword $(subst :, ,$(GOPATH)))/bin
+GOBIN ?= $(firstword $(subst :, ,$(shell go env GOPATH)))/bin
 export PATH := $(GOBIN):$(PATH)
 
 TOGO = $(GOBIN)/togo
 $(TOGO):
-	go get $(GOGETFLAGS) github.com/flazz/togo
+	go install github.com/flazz/togo@latest
 
 GOYACC = $(GOBIN)/goyacc
 $(GOYACC):
-	go get $(GOGETFLAGS) golang.org/x/tools/cmd/goyacc
+	go install golang.org/x/tools/cmd/goyacc@latest
 
 GOFUZZBUILD = $(GOBIN)/go114-fuzz-build
 $(GOFUZZBUILD):
-	go get $(GOGETFLAGS) github.com/mdempsky/go114-fuzz-build
+	go install github.com/mdempsky/go114-fuzz-build@latest
 
 GOFUZZ = $(GOBIN)/go-fuzz
 $(GOFUZZ):
-	go get $(GOGETFLAGS) github.com/dvyukov/go-fuzz/go-fuzz
+	go install github.com/dvyukov/go-fuzz/go-fuzz@latest
 
 GOTESTSUM = $(GOBIN)/gotestsum
 $(GOTESTSUM):
-	go get $(GOGETFLAGS) gotest.tools/gotestsum
+	go install gotest.tools/gotestsum@latest
 
 BENCHSTAT = $(GOBIN)/benchstat
 $(BENCHSTAT):
-	go get $(GOGETFLAGS) golang.org/x/perf/cmd/benchstat
+	go install golang.org/x/perf/cmd/benchstat@latest
+
+GOSEC = $(GOBIN)/gosec
+$(GOSEC):
+	go install github.com/securego/gosec/v2/cmd/gosec@latest
+
+GOLANGCILINT = $(GOBIN)/golangci-lint
+$(GOLANGCILINT):
+	go install github.com/golangci/golangci-lint/cmd/golangci-lint@latest
 
 
 .PHONY: clean covclean crossclean depclean veryclean
@@ -100,9 +104,10 @@
 	rm -f .d/*  .*dep-stamp
 veryclean: clean depclean
 
+# lint
 .PHONY: lint
-lint:
-	golangci-lint run ./...
+lint:  $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | $(GOLANGCILINT)
+	$(GOLANGCILINT) run ./...
 
 branch := $(shell git rev-parse --abbrev-ref HEAD)
 version := $(shell git describe --tags --always --dirty)
@@ -131,7 +136,7 @@
 	$(MAKEDEPEND)
 	go build -gcflags "$(GO_GCFLAGS)" -ldflags "$(GO_LDFLAGS)" -o $@ $<
 
-internal/vm/parser/parser.go: internal/vm/parser/parser.y | $(GOYACC)
+internal/runtime/compiler/parser/parser.go: internal/runtime/compiler/parser/parser.y | $(GOYACC)
 	go generate -x ./$(@D)
 
 internal/mtail/logo.ico: logo.png
@@ -146,7 +151,9 @@
 #
 .PHONY: print-version
 print-version:
-	@go version
+	which go
+	go version
+	go env
 
 ###
 ## Install rules
@@ -185,11 +192,10 @@
 
 $(TESTRESULTS)/test-output.xml $(TESTCOVERPROFILE): $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp $(GOTESTSUM)
 	mkdir -p $(TESTRESULTS)
-	gotestsum --debug --junitfile $(TESTRESULTS)/test-output.xml -- $(GO_TEST_FLAGS) -cpu 1,2,4 -race -parallel 1 -coverprofile=$(TESTCOVERPROFILE) --covermode=atomic -v -timeout=${timeout} -gcflags "$(GO_GCFLAGS)" ./...
+	gotestsum --debug --junitfile $(TESTRESULTS)/test-output.xml -- $(GO_TEST_FLAGS) -p=1 -cpu=1,2,4 -race -count=1 -parallel=1 -coverprofile=$(TESTCOVERPROFILE) --covermode=atomic -v -timeout=30m -gcflags "$(GO_GCFLAGS)" ./...
 
 .PHONY: bench
 bench: $(TESTRESULTS)/benchmark-results-$(HEAD_REF).txt
-
 $(TESTRESULTS)/benchmark-results-$(HEAD_REF).txt: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version .dep-stamp
 	mkdir -p $(TESTRESULTS)
 	go test -cpu 1,2,4 -bench=. -count=$(BENCH_COUNT) -timeout=${benchtimeout} -run=^a ./... | tee $@
@@ -197,13 +203,16 @@
 .PHONY: benchstat
 benchstat: $(TESTRESULTS)/benchstat.txt
 $(TESTRESULTS)/benchstat.txt: $(TESTRESULTS)/benchmark-results-$(HEAD_REF).txt | print-version $(BENCHSTAT)
-	(test -s $(TESTRESULTS)/benchmark-results-$(BASE_REF).txt && benchstat $(TESTRESULTS)/benchmark-results-$(BASE_REF).txt $< || benchstat $<) | tee $@
+	(test -s $(TESTRESULTS)/benchmark-results-$(BASE_REF).txt && benchstat -sort=-delta $(TESTRESULTS)/benchmark-results-$(BASE_REF).txt $< || benchstat $<) | tee $@
 
 
 PACKAGES := $(shell go list -f '{{.Dir}}' ./... | grep -v /vendor/ | grep -v /cmd/ | sed -e "s@$$(pwd)@.@")
 
 .PHONY: testall
-testall: testrace bench regtest
+testall: testrace fuzz-regtest bench
+
+.PHONY: checkall
+checkall: check all fuzz-targets
 
 ## make u a container
 .PHONY: container
@@ -214,30 +223,36 @@
 	    --build-arg build_date=$(shell date -Iseconds --utc) \
 	    .
 
-# Append the bin subdirs of every element of the GOPATH list to PATH, so we can find goyacc.
-empty :=
-space := $(empty) $(empty)
-export PATH := $(PATH):$(subst $(space),:,$(patsubst %,%/bin,$(subst :, ,$(GOPATH))))
+## Run gosec
+.PHONY: gosec
+gosec: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | $(GOSEC)
+	$(GOSEC) -tags fuzz ./...
+
 
 ###
 ## Fuzz testing
 #
 
 # These flags set compatibility with OSS-Fuzz
-CXX ?= clang-9
-CXXFLAGS ?=
-LIB_FUZZING_ENGINE ?= -fsanitize=fuzzer
+CXX = clang
+CXXFLAGS ?= -fsanitize=fuzzer,address
+LIB_FUZZING_ENGINE ?=
 OUT ?= .
 
+.PHONY: fuzz-targets
+fuzz-targets: $(OUT)/vm-fuzzer
+
 $(OUT)/vm-fuzzer: $(GOFILES) | $(GOFUZZBUILD)
-	go114-fuzz-build -o fuzzer.a ./internal/vm
+	go114-fuzz-build -o fuzzer.a ./internal/runtime
 	$(CXX) $(CXXFLAGS) $(LIB_FUZZING_ENGINE) fuzzer.a -lpthread -o $(OUT)/vm-fuzzer
 
 $(OUT)/vm-fuzzer.dict: mgen
 	./mgen --dictionary | sort > $@
 
-$(OUT)/vm-fuzzer_seed_corpus.zip: $(wildcard examples/*.mtail) $(wildcard internal/vm/fuzz/*.mtail)
+$(OUT)/vm-fuzzer_seed_corpus.zip: $(wildcard examples/*.mtail) $(wildcard internal/runtime/fuzz/*.mtail)
 	zip -j $@ $^
+
+FUZZER_FLAGS=-rss_limit_mb=4096 -timeout=60s
 
 .INTERMEDIATE: SEED/*
 SEED: $(OUT)/vm-fuzzer_seed_corpus.zip
@@ -247,18 +262,18 @@
 .PHONY: fuzz
 fuzz: SEED $(OUT)/vm-fuzzer $(OUT)/vm-fuzzer.dict
 	mkdir -p CORPUS
-	$(OUT)/vm-fuzzer -dict=$(OUT)/vm-fuzzer.dict CORPUS SEED
+	$(OUT)/vm-fuzzer $(FUZZER_FLAGS) -dict=$(OUT)/vm-fuzzer.dict CORPUS SEED
 
 .PHONY: fuzz-regtest
 fuzz-regtest: $(OUT)/vm-fuzzer SEED
-	$(OUT)/vm-fuzzer -rss_limit_mb=4096 $(shell ls SEED/*.mtail)
+	$(OUT)/vm-fuzzer $(FUZZER_FLAGS) $(shell ls SEED/*.mtail)
 
 CRASH ?=
 
 .PHONY: fuzz-repro
 fuzz-repro: $(OUT)/vm-fuzzer mtail
-	$(OUT)/vm-fuzzer $(CRASH) || true  # Want to continue
-	./mtail --logtostderr --vmodule=loader=2,checker=2,types=2 --mtailDebug=3 --dump_ast_types --dump_bytecode --compile_only --progs $(CRASH)
+	$(OUT)/vm-fuzzer $(FUZZER_FLAGS) $(CRASH) || true  # Want to continue
+	./mtail --logtostderr --vmodule=runtime=2,lexer=2,parser=2,checker=2,types=2,codegen=2 --mtailDebug=3 --dump_ast --dump_ast_types --dump_bytecode --compile_only --progs $(CRASH)
 
 # make fuzz-min CRASH=example crash
 .PHONY: fuzz-min
@@ -270,7 +285,7 @@
 #
 .PHONY: install_deps
 install_deps: .dep-stamp
-.dep-stamp: | $(GOGENFILES) print-version
+.dep-stamp: | print-version $(GOGENFILES)
 	go mod download
 	touch $@
 
@@ -296,7 +311,7 @@
 #
 GHI = $(GOBIN)/ghi
 $(GHI):
-	go get $(GOGETFLAGS) github.com/markbates/ghi
+	go install github.com/markbates/ghi@latest
 
 issue-fetch: | $(GHI)
 	ghi fetch

=== debian/changelog ===
mtail (3.0.0~rc48-1) unstable; urgency=medium

  * New upstream release.
  * When using gccgo, ensure the right version is used.
  * Add distribution info as Branch variable.
  * debian/rules: Add missing make snippet, default to full tests.
  * debian/rules: set tests timeout.
  * debian/rules: use dh_auto_test for race tests too.
  * Refresh patches, removing unneeded patch.
  * debian/rules: update paths of extra files.
  * debian/rules: Increase test timeouts.

 -- Martina Ferrari <tina@debian.org>  Wed, 29 Dec 2021 00:42:59 +0000

=== debian/control ===
--- 
+++ 
@@ -7,6 +7,7 @@
 Build-Depends: debhelper-compat (= 13),
                dh-golang (>= 1.17~),
                golang-any,
+               golang-go (>= 2:1.14~) | gccgo (>= 4:10~),
                golang-github-fsnotify-fsnotify-dev,
                golang-github-golang-groupcache-dev,
                golang-github-google-go-cmp-dev,

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk

#export DH_VERBOSE=1
export DH_GOPKG := github.com/google/mtail
export DH_GOLANG_EXCLUDES := $(DH_GOPKG)/cmd/mgen $(DH_GOPKG)/cmd/mdot
export DH_GOLANG_INSTALL_EXTRA := examples/ \
    internal/mtail/golden/ internal/mtail/testdata/ \
    internal/runtime/compiler/parser/parser.y
# Build parser.go
export DH_GOLANG_GO_GENERATE := 1

BUILDDIR := $(CURDIR)/build
BUILDFLAGS = -ldflags \
  " -X main.Version=$(DEB_VERSION_UPSTREAM)\
    -X main.Revision=$(DEB_VERSION)\
    -X main.Branch=$(DEB_VENDOR)/$(DEB_DISTRIBUTION)"

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=$(BUILDDIR)

override_dh_auto_build:
	dh_auto_build -- $(BUILDFLAGS)

# Use longer internal timeouts.
override_dh_auto_test: export CI = true
override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifneq ($(DEB_HOST_ARCH_BITS),32)
	dh_auto_test -- -timeout 30s
else
	# soft fail on non 64-bit architectures:
	# https://github.com/google/mtail/issues/313
	dh_auto_test -- -timeout 30s \
            || echo "W: ignoring known test failure on 32-bit architectures"
endif
	# Only run race tests on amd64.
	test "$(DEB_HOST_ARCH_CPU)" != amd64 || \
	    dh_auto_test -- -timeout 5m -race -tags=integration
endif

override_dh_installinit:
	dh_installinit --no-enable --no-start

override_dh_installsystemd:
	dh_installsystemd --no-enable --no-start

override_dh_auto_install:
	dh_auto_install -- --no-source

## mtail 3.0.0~rc49

=== Makefile ===
--- 
+++ 
@@ -33,10 +33,12 @@
 # This instruction loads any dependency includes for our targets.
 -include $(patsubst %,$(DEPDIR)/%.d,$(TARGETS))
 
-# Set the timeout for tests run under the race detector.
-timeout := 120s
+# Set the timeout for tests.
+test_timeout := 20s
+testrace_timeout := 4m
 ifeq ($(CI),true)
-timeout := 10m
+test_timeout := 100s
+testrace_timeout := 20m
 endif
 # Let the benchmarks run for a long time.  The timeout is for the total time of
 # all benchmarks, not per bench.
@@ -170,11 +172,11 @@
 
 .PHONY: test check
 check test: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version $(LOGO_GO) .dep-stamp
-	go test $(GO_TEST_FLAGS) -gcflags "$(GO_GCFLAGS)" -timeout 10s ./...
+	go test $(GO_TEST_FLAGS) -gcflags "$(GO_GCFLAGS)" -timeout ${test_timeout} ./...
 
 .PHONY: testrace
 testrace: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version $(LOGO_GO) .dep-stamp
-	go test $(GO_TEST_FLAGS) -gcflags "$(GO_GCFLAGS)" -timeout ${timeout} -race -v ./...
+	go test $(GO_TEST_FLAGS) -gcflags "$(GO_GCFLAGS)" -timeout ${testrace_timeout} -race -v ./...
 
 .PHONY: smoke
 smoke: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version $(LOGO_GO) .dep-stamp
@@ -182,7 +184,7 @@
 
 .PHONY: regtest
 regtest: $(GOFILES) $(GOGENFILES) $(GOTESTFILES) | print-version $(LOGO_GO) .dep-stamp
-	go test $(GO_TEST_FLAGS) -gcflags "$(GO_GCFLAGS)" -v -timeout=${timeout} ./...
+	go test $(GO_TEST_FLAGS) -gcflags "$(GO_GCFLAGS)" -v -timeout=${testrace_timeout} ./...
 
 TESTRESULTS ?= test-results
 TESTCOVERPROFILE ?= out.coverprofile

=== debian/changelog ===
mtail (3.0.0~rc49-1) unstable; urgency=medium

  * New upstream release.
  * Refresh and remove patches already applied upstream.

 -- Martina Ferrari <tina@debian.org>  Wed, 25 May 2022 18:16:47 +0000

mtail (3.0.0~rc48-4) unstable; urgency=medium

  * debian/service: avoid shell glob expansion.
  * debian/service: Use correct path for test.

 -- Martina Ferrari <tina@debian.org>  Wed, 30 Mar 2022 14:39:07 +0000

mtail (3.0.0~rc48-3) unstable; urgency=medium

  * Backport fixes sent upstream.
  * debian/copyright: update years.

 -- Martina Ferrari <tina@debian.org>  Mon, 03 Jan 2022 21:55:04 +0000

mtail (3.0.0~rc48-2) unstable; urgency=medium

  * Increase test timeouts.
    Back-port https://github.com/google/mtail/pull/612 and modify debian/rules
    reflecting the updated timeouts.
  * Stop ignoring test failures in 32-bit arches.
    Since this problem was apparently only present in golang 1.14, increase the
    dependency version and remove the test failure exception.
  * debian/copyright: update years.

 -- Martina Ferrari <tina@debian.org>  Fri, 31 Dec 2021 21:33:38 +0000

## mtail 3.0.0~rc50

=== debian/changelog ===
mtail (3.0.0~rc50-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.
  * Automatic fixes from cme: remove outdated versioned
    dependencies, conflicts with packages no longer in debian, update
    Standards-Version (no changes), and other automated changes.
  * Add versioned dependency on client-golang.
  * Move golang versioned dependency to golang-any, and update it to 1.17.
  * Remove now unneeded patch.

 -- Martina Ferrari <tina@debian.org>  Thu, 08 Sep 2022 20:49:42 +0000

mtail (3.0.0~rc50-1) unstable; urgency=medium

  * New upstream release.
  * Add patch to fix build errors in go 1.18. Closes: #1017291

 -- Martina Ferrari <tina@debian.org>  Tue, 23 Aug 2022 14:42:45 +0000

mtail (3.0.0~rc48-3~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.
  * Add patch to avoid depending on newer client-golang.

 -- Martina Ferrari <tina@debian.org>  Mon, 03 Jan 2022 22:07:35 +0000

mtail (3.0.0~rc43-4~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Martina Ferrari <tina@debian.org>  Wed, 15 Dec 2021 09:37:10 +0000

=== debian/control ===
--- 
+++ 
@@ -5,23 +5,22 @@
 Testsuite: autopkgtest-pkg-go
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
-               dh-golang (>= 1.17~),
-               golang-any,
-               golang-go (>= 2:1.14~) | gccgo (>= 4:10~),
+               dh-golang,
+               golang-any (>= 2:1.17~),
                golang-github-fsnotify-fsnotify-dev,
                golang-github-golang-groupcache-dev,
                golang-github-google-go-cmp-dev,
                golang-github-pkg-errors-dev,
-               golang-github-prometheus-client-golang-dev,
+               golang-github-prometheus-client-golang-dev (>= 1.11~),
                golang-glog-dev,
                golang-go.opencensus-dev,
                golang-golang-x-tools,
                tzdata,
-Standards-Version: 4.6.0.1
-Rules-Requires-Root: no
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/go-team/packages/mtail
 Vcs-Git: https://salsa.debian.org/go-team/packages/mtail.git
 Homepage: https://github.com/google/mtail/
+Rules-Requires-Root: no
 XS-Go-Import-Path: github.com/google/mtail
 
 Package: mtail
@@ -30,7 +29,6 @@
          tzdata,
          ${misc:Depends},
          ${shlibs:Depends},
-Conflicts: monkeytail,
 Built-Using: ${misc:Built-Using},
 Description: Extract monitoring data from logs for collection in a timeseries database
  Mtail is a tool for extracting metrics from application logs to be exported
